import request from "../utils/request";

/**
 * 登录
 * @param params 
 */
function login(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "/v3/login",
    data: params.data,
    success: params.success
  })
}

/**
 * 获取手机号
 * @param params 
 */
function getPhone(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "/v3/getuserphonenumber",
    data: params.data,
    header: {
      Authorization: wx.getStorageSync("token"),
      ...params.header
    },
    success: params.success
  })
}

/**
 * 下单
 * @param params 
 */
function createOrder(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "/v3/jsApiPay",
    data: params.data,
    header: {
      Authorization: wx.getStorageSync("token"),
      ...params.header
    },
    success: params.success
  })
}

/**
 * 获取状态
 * @param params 
 */
function getUser(params: WechatMiniprogram.requestParamsData) {
  if (!wx.getStorageSync("token")) return;
  return request({
    url: "/v3/user-state",
    data: params.data,
    noloading: params.noloading,
    header: {
      Authorization: wx.getStorageSync("token"),
      ...params.header
    },
    success: params.success,
    complete: params.complete || undefined
  })
}

/**
 * 获取视频结果
 * @param params 
 */
function getVideo(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "/v3/getVideo",
    data: params.data,
    header: {
      Authorization: wx.getStorageSync("token"),
      ...params.header
    },
    success: params.success
  })
}

/**
 * 保存用户信息
 * @param params 
 */
function seaveUserData(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "/v3/save-info",
    data: params.data,
    method: params.method,
    header: {
      Authorization: wx.getStorageSync("token"),
      ...params.header
    },
    success: params.success
  })
}

/**
 * 获取页面信息
 * @param params 
 */
function getPageInfo(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "https://djweb.smcic.net/video/PageInfo.json?" + Date.now(),
    data: params.data,
    method: params.method,
    baseUrlNone: true,
    header: {
      ...params.header
    },
    success: params.success
  })
}

/**
 * 获取学校列表
 * @param params 
 */
function getSchoolList(params: WechatMiniprogram.requestParamsData) {
  return request({
    url: "/v3/organization",
    data: params.data,
    method: params.method,
    header: {
      Authorization: wx.getStorageSync("token"),
      ...params.header
    },
    success: params.success
  })
}

export default {
  getSchoolList,
  login,
  getPhone,
  createOrder,
  getUser,
  getVideo,
  seaveUserData,
  getPageInfo
}
