// pages/home/index.ts
const app = getApp<IAppOption>();
import { compareVersion } from "../../utils/util";
Page({

  /**
   * 页面的初始数据
   */
  data: {
    pageBGIMG: "",
    btnBGIMG: "",
    btnText: "登记/查询选手信息"
  },

  lvru() {
    app.getUser({
      data: {},
      success: (res: any) => {
        if (!res.SAVE_USER_INFO) {
          // 未上传用户信息，跳转用户信息页
          wx.navigateTo({
            url: "/pages/entry/index"
          })
          return;
        }
        if (!res.UPLOAD_FACE) {
          // 未上传人脸信息，跳转人脸采集页
          let url = "/pages/faceRecognition/index";
          const version: string = app.globalData.SystemInfo?.SDKVersion || "";
          if (compareVersion(version, "2.25.0") !== -1) url = "/pages/faceRecognitionVK/index";
          wx.navigateTo({ url })
          return;
        }
        wx.navigateTo({
          url: "/pages/downloadPage/index"
        })
      }
    })
  },

  inited(res: any) {
    const { BGIMG, btnBGIMG } = res?.homePage;
    this.setData({
      pageBGIMG: BGIMG + "?" + Date.now(),
      btnBGIMG: btnBGIMG + "?" + Date.now()
    })
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad() {
    app.getPageInfo({
      success: (res: any) => {
        const configPage = res || {};
        this.inited(configPage);
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() { },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    // 获取用户信息
    // app.getUser({
    //   data: {},
    //   success: (res: any) => {
    //     if (!res) return;
    //     if (res.UPLOAD_FACE && res.SAVE_USER_INFO) {
    //       // 已经录过脸并且用户信息已经上传，跳转视频下载页
    //       // this.setData({
    //       //   btnText: "进入下载页"
    //       // })
    //       return wx.reLaunch({
    //         url: "/pages/downloadPage/index"
    //       })
    //     }
    //   },
    //   complete: () => {
    //     app.globalData.getUserLoad = false;
    //   }
    // })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() { },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() { },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() { },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() { },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() { }
})

export { }
