import { base } from "../config/index"
import { errHttp } from "./util";

export default function request(params: WechatMiniprogram.requestParamsData) {
  !params.noloading && wx.showLoading({
    title: ""
  })
  const url = params.baseUrlNone ? params.url : base.url + params.url
  return wx.request({
    url,
    data: params.data,
    header: params.header,
    dataType: params.dataType || 'json',
    success: (res: any) => {
      !params.noloading && wx.hideLoading();
      if (res.statusCode !== 200 || res.data.code !== 0) {
        // code 401  token过期
        errHttp(res.data.message || res.data.message);
        return;
      }
      params.success && params.success(res.data.data);
    },
    method: params.method || "GET",
    fail: err => {
      !params.noloading && wx.hideLoading();
      wx.showToast({
        title: err.errMsg || "请稍后再试",
        icon: "none",
        duration: 2000
      })
    },
    complete: (com) => {
      params.complete && params.complete(com);
    }
  })
}